<template>
  <div class="hero" v-bind:style="{backgroundColor: color}">
    <div class="dead" v-if="!entity.alive">Mort.</div>
    <div class="content">
      <h3>{{ entity.name }}</h3>
      <img :src="entity.imgUrl" alt="">
      <h4>PV: {{ Math.round(entity.health * 100) / 100}} / {{ entity.maxHealth}}</h4>
      <h5>Energie: {{ Math.round(entity.energy * 100) / 100 }} / {{entity.maxEnergy}}</h5>
      <h5>Nourriture: {{ Math.round(entity.hunger * 100) / 100}} / {{entity.maxHunger}}</h5>
      <p v-for="(d, i) in entity.attributes()" v-bind:key="i">{{ d.name }} : {{ d.value }}</p>
    </div>
    <div class="progress">
      <div class="progress-value" v-bind:style="{width: entity.pwidth()}"></div>
      <div class="progress-bar"></div>
    </div>
  </div>
</template>

<script>
import {Character} from "../../game/entity/character";

export default {
  name: "CCharacter",
  props: {
    entity: Character
  },
  data: function() {
    return {
      color: "#FFFFFF"
    }
  }
}
</script>

<style scoped>

.hero {
  padding: 12px;
  box-shadow: 0 5px 50px rgba(40,40,40,0.15);
  border-radius: 4px;
  margin: 16px;
  flex: 1 1 auto;
  min-width: 150px;
  max-width: 250px;

  transition: all 0.2s ease-in;
  position: relative;
}

h4 {
  margin: 6px 0;
}

h5 {
  margin: 2px 0;
}

.dead {
  background: rgba(75,75,75,0.85);
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
  color: white;
}

.progress {
  display: inline-block;
  position: absolute;
  left: 0;
  bottom: 0;
  right: 0;
  height: 6px;
}

.progress-bar {
  background: gray;
  display: block;
  height: inherit;
}

.progress-value {
  background: #57e2b1;
  position: absolute;
  left: 0;
  bottom: 0;
  height: inherit;
  transition: all 100ms ease-in-out;
}

</style>